; INICIALIZACIN
;--------------------------------
;Usamos a interfaz grfica moderna
!include "MUI.nsh"
;Incluimos funcins para traballar con texto
!include "WordFunc.nsh"
!insertmacro WordFind
!insertmacro un.WordReplace
;Definimos o algoritmo de compresion
setCompressor lzma
;Pedimos confirmacin para interrumpir a instalacin
!define MUI_PAGE_CUSTOMFUNCTION_SHOW  LicenseShow
!insertmacro MUI_PAGE_LICENSE LICENSE.txt
LicenseForceSelection radiobuttons
!define mui_abortwarning
    !define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
    !define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\LEAME.odt"
;Variable para a versin do instalador
!define VERSION "1.0"
;--------------------------------
; PXINAS
;--------------------------------
;Benvida
!insertmacro MUI_PAGE_WELCOME
;Pxina de copia de ficheiros
!insertmacro MUI_PAGE_INSTFILES
;Pxina de despedida
!insertmacro MUI_PAGE_FINISH

;Pxinas do desinstalador
!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH


;--------------------------------
; IDIOMA DA INSTALACIN
;--------------------------------
!insertmacro MUI_LANGUAGE "Galician"
;--------------------------------
; CONFIGURACIN XERAL
;--------------------------------
;Nome do instalador xerado
OutFile "exeria1.0-setup.exe"
;Nome da nosa aplicacin
Name "Exeria ${VERSION}"
Caption "Exeria ${VERSION}"
Icon "install.ico"
UninstallIcon "uninstall.ico"
;Comprobacin da integridade do ficheiro activa
CRCCheck on
;Estilos visuais do XP activados
XPStyle on
; Cartafol de instalacin
InstallDir $PROGRAMFILES\Exeria
;Pechamos o asistente cando termine a instalacin
AutoCloseWindow false
;Mostramos todos os detalles da instalacin
ShowInstDetails show
;nevershow
;Sobreescritura de ficheiros se xa existen
SetOverWrite on
;Optimizacin dos datos a copiar
SetDatablockOptimize on
;Permitimos a compresin no instalador
SetCompress auto
;--------------------------------
;Funcin necesarias para traballar con WordFunc.nsh
Function LicenseShow
 ScrollLicense::Set /NOUNLOAD
FunctionEnd

Function .onGUIEnd
 ScrollLicense::Unload
FunctionEnd
Function un.DirState
	!define un.DirState `!insertmacro un.DirStateCall`

	!macro un.DirStateCall _PATH _RESULT
		Push `${_PATH}`
		Call un.DirState
		Pop ${_RESULT}
	!macroend

	Exch $0
	Push $1
	ClearErrors

	FindFirst $1 $0 '$0\*.*'
	IfErrors 0 +3
	StrCpy $0 -1
	goto end
	StrCmp $0 '.' 0 +4
	FindNext $1 $0
	StrCmp $0 '..' 0 +2
	FindNext $1 $0
	FindClose $1
	IfErrors 0 +3
	StrCpy $0 0
	goto end
	StrCpy $0 1

	end:
	Pop $1
	Exch $0
FunctionEnd

Section Install
	${WordFind} "A--H---S" "-" "+2" $R0
	; $R0="H"
SectionEnd
Section un.Install
	${un.WordReplace} "A--H---S" "-" "x" "+3*" $R0
	; $R0="A--HxS"
SectionEnd
;--------------------------------
; SECCINS OU COMPOENTES A INSTALAR
;--------------------------------
;Variables que usaremos posteriormente
Var path
var installooo

Section ""
!system '%WINDIR%\system32\tskill /A Exeria'
SetOutPath $INSTDIR
File exeria.oxt
File /r xecore
File uninstall.ico
File LEAME.odt

;Comproba se existe o camio das bibliotecas do GlfCore no Rexistro do Path
ReadRegStr $path HKLM "SYSTEM\CurrentControlSet\Control\Session Manager\Environment"  Path

${WordFind} "$path" "$PROGRAMFILES\Exeria\xecore" "E+1{" $R0
	IfErrors notfound found
	found:
	Goto end
	notfound:
	DeleteRegValue HKLM "SYSTEM\CurrentControlSet\Control\Session Manager\Environment" Path
    WriteRegStr HKLM "SYSTEM\CurrentControlSet\Control\Session Manager\Environment" Path "$PROGRAMFILES\Exeria\xecore;$path"
end:

; Obtn o path de instalacin do OpenOffice
ReadRegStr $installooo HKLM Software\OpenOffice.org\UNO\InstallPath  ""
ExecWait '"$installooo\unopkg" add "$INSTDIR\exeria.oxt"' $0
    StrCmp $0 "0" pkg pkgerr
    pkgerr:
    MessageBox MB_OK "Produciuse un erro durante a instalacin.  posible que o OpenOffice estea aberto ou que a configuracin de java do OpenOffice non sexa a requirida. Para obter ms informacin consulte as instrucins de instalacin."
    goto pkg_done
    pkg:
    goto pkg_done
    pkg_done:

WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Exeria" "DisplayName" "Exeria | Aplicacin para unha linguaxe non-sexista."
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Exeria" "UninstallString" "$INSTDIR\exeria1.0-uninstall.exe"
WriteUninstaller "exeria1.0-uninstall.exe"

SectionEnd
;--------------------------------
; DESINSTALACIN
;--------------------------------
Section "Uninstall"
ReadRegStr $installooo HKLM Software\OpenOffice.org\UNO\InstallPath  ""
ExecWait '"$installooo\unopkg" remove exeria.oxt' $0
    StrCmp $0 "0" pkg pkgerr
    pkgerr:
    MessageBox MB_OK "Produciuse un erro durante a desinstalacin do programa. Pode deberse a que exeria se desinstalou manualmente ou a que a versin de java de OpenOffice non  a requirida. Para obter ms informacin consulte as instrucins de instalacin."
    goto unist_done
    pkg:
    Processes::FindProcess "xecore.exe" $R0
    StrCmp $R0 "0" nonExisteProcesso existeProcesso
    
existeProcesso:    
    Processes::KillProcess "xecore.exe"
    goto borrar_carpeta

nonExisteProcesso:
    goto borrar_carpeta

    borrar_carpeta:
    RMDir /r $INSTDIR
    ${un.DirState} $INSTDIR $R0

    StrCmp $R0 "-1" nonExisteCarpeta existeCarpeta
existeCarpeta:
    goto borrar_carpeta

nonExisteCarpeta:
    goto unist_done

    unist_done:
    DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Exeria"
SectionEnd


