/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

#include "GrammarService.h"

GrammarService::GrammarService()
{
	int n = 1;

	if ((fd = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) {
		perror("socket");
		exit(-1);
	}

	if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (void *)&n, sizeof(int)) < 0) {
		perror("setsockopt");
		exit(-1);
	}

	server.sin_family 	= AF_INET;
	server.sin_port 	= htons(PORT);
	server.sin_addr.s_addr 	= INADDR_ANY;
	/* INADDR_ANY coloca nuestra direccin IP automticamente */

	bzero(&(server.sin_zero),8);

	if(bind(fd,(struct sockaddr*)&server,
	           sizeof(struct sockaddr)) == -1) {
		perror("bind");
	    	exit(-1);
	}

	if(listen(fd, BACKLOG) == -1) {
		perror("listen");
		exit(-1);
   	}

}

GrammarService::~GrammarService()
{
	close(fd);
}

string GrammarService::ReadSentence(void)
{
	int numbytes;
	socklen_t sin_size = sizeof(struct sockaddr_in);

	/* A continuacin la llamada a accept() */
	if ((fd2 = accept(fd, (struct sockaddr *)&client, &sin_size)) == -1) {
		perror("accept");
		exit(-1);
	}

  	if ((numbytes = recv(fd2, buf, MAXDATASIZE,0)) == -1) {
		perror("recv");
	  	exit(-1);
  	}

  	buf[numbytes]='\0';
	string sentence = buf;
    //close(fd2);
    return sentence;
}

void GrammarService::SendSentence(string text)
{
	send(fd2, text.c_str(),text.size(), 0);
	close(fd2);
}
