/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>

#include "HashException.h"

using namespace std;

HashException::HashException(const string path_exception, const string path_lemma)
{
	int res;

	_db_excep = new Db(NULL, DB_CXX_NO_EXCEPTIONS);
	_db_lemma = new Db(NULL, DB_CXX_NO_EXCEPTIONS);

	if ((res = _db_excep->open(NULL, path_exception.c_str(), NULL,DB_HASH, DB_RDONLY, 0))) {
		exit(res);
	}

	if ((res = _db_lemma->open(NULL, path_lemma.c_str(), NULL,DB_HASH, DB_RDONLY, 0))) {
		exit(res);
	}
}

HashException::~HashException()
{
	_db_excep->close(0);
	_db_lemma->close(0);

	delete _db_excep;
	delete _db_lemma;
}

int HashException::searchPattern(const string pattern, vector<string> vector_lemma)
{
	int found = 0;

	if (searchInHashException(pattern))
		if (this->searchLemma(vector_lemma))
			found = 1;

	return found;
}

int HashException::searchInHashException(const string pattern) {
	Dbt key, data;
	int error;
	int found = 0;

	key.set_data((void *) pattern.c_str());
	key.set_size(pattern.length());

	if ( (error = _db_excep->get(NULL, &key, &data, 0)) == 0)
		found = 1;

	return found;
}

int HashException::searchInHashLemma(const string lemma) {
	Dbt key, data;
	int found = 0;
	int error;

	key.set_data((void *) lemma.c_str());
	key.set_size(lemma.length());

	if ( (error = _db_lemma->get(NULL, &key, &data, 0)) == 0)
		found = 1;

	return found;
}

int HashException::searchLemma(vector<string> v_lemma) {
	int found	= 0;
	int i		= 0;
	int size	= v_lemma.size();;

	while (i < size && !found) {
		if (searchInHashLemma(v_lemma.at(i)))
			found= 1;

		i++;
	}

	return found;
}
