/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>

#include "Package.h"

Package::Package(string buffer)
{
	spell	= false;
	check	= false;
	exit	= false;
	form	= false;
	info	= false;

	buf 	= new string(buffer);
	int pos = IsFormated();

	if (pos > -1) {
		if (buf->substr(0, pos) == "CHECK")
			check = true;
		if (buf->substr(0, pos) == "SPELL")
			spell = true;
		if (buf->substr(0, pos) == "EXIT")
			exit = true;
		if (buf->substr(0, pos) == "FORM")
			form = true;
		if (buf->substr(0, pos) == "INFO")
			info = true;

		if (check || spell || form || info) {
			if ( pos + 1 < buf->size() )
				phrase = buf->substr(pos + 1, buf->size());
		}
	}
}

Package::~Package()
{
	delete buf;
}

bool Package::IsExit()
{
	return exit;
}

bool Package::IsCheck()
{
	return check;
}

bool Package::IsSpell()
{
	return spell;
}

bool Package::IsForm()
{
	return form;
}

bool Package::IsInfoDes()
{
	return info;
}

string Package::GetPhrase()
{
	return phrase;
}

bool Package::IsValid()
{
	return (!check && !spell ? false : true);
}

string Package::SetResponse(string resp)
{
	string buffer;


	if (check)
		buffer = "CHECK|" + resp;
	if (spell)
		buffer = "SPELL|" + resp;
	if (form)
		buffer = "FORM|" + resp;
	if (info)
		buffer = "INFO|" + resp;

	return buffer;
}

int Package::GetForm()
{
	int i;

	if (sscanf(phrase.c_str(), "%d", &i) == EOF)
		return 0x1011;
	else
		return i;
}

// Private
int Package::IsFormated()
{
	string::size_type pos = buf->find("|", 0);

	if (pos == string::npos)
		return -1;
	else
		return pos;
}
