/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>

#include "freeling.h"
#include "freeling/traces.h"
#ifndef PHRASE_H
#define PHRASE_H
#include "Phrase.h"
#endif

using namespace std;

class Disambiguator {	
public:
	// Public constructor and destructor
	Disambiguator(
					const string path_tokenizer,
					const string path_splitter,
					const string path_quanties,
					const string path_locutions,
					const string path_suffix,
					const string path_probability,
					const string path_dictionary,
					const string path_np,
					const string path_punctuation,
					const string path_tagger,
					const string language);	
	~Disambiguator();

	// Public routines		
	void run(Phrase *ora);

private:
	tokenizer 		*_tk;
	splitter 		*_sp;
	maco_options 	*_opt;
	maco			*_morfo;
	hmm_tagger		*_tg;	
};
