/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <db_cxx.h>

#define CREATE DB_CREATE
#define READ DB_RDONLY

#define DB_NO_ERROR			0x0000
#define DB_OUT_OF_MEMORY		0x0010
#define DB_ERROR_ON_CREATE	0x0002
#define DB_ERROR_ON_OPEN		0x0003
#define DB_ERROR_ON_CLOSE		0x0004
#define DB_KEY_EXIST			0x0005
#define DB_ERROR_ON_CURSOR	0x0006

using namespace std;

class HashFile {
	public:
		static int openDb(const string path, Db *db, int flag);
		static int closeDb(Db *mydb);
		static int insertDb(Db *mydb, Dbt key, Dbt data);
	
		static int createCursor(Db *mydb, Dbc *cursor);
		static int moveNextCursor(Dbc *cursor, Dbt *key, Dbt *data);
		static int closeCursor(Dbc *cursor);
};


