/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <pcrecpp.h>
#include "freeling.h"
#include "freeling/traces.h"
#ifndef PHRASE_H
#define PHRASE_H
#include "Phrase.h"
#endif PHRASE_H
#ifndef PHRASE_STRUCTURE_H
#define PHRASE_STRUCTURE_H
#include "PhraseStructure.h"
#endif PHRASE_STRUCTURE_H
#ifndef SUGGESTION_H
#define SUGGESTION_H
#include "Suggestion.h"
#endif
#ifndef UTIL_H
#define UTIL_H
#include "Util.h"
#endif

using namespace std;


class Solution {	
public:
	// Public constructor and destructor
	Solution(PhraseStructure ora);
	~Solution();

	// Public routines				
	int buildGrammarBetweenArticleAndName(	int pos_error, 
											vector<string> v_sugg, 
											vector<string> v_sugg_tagged, 
											vector<string> *v_cadidates, 
											string *error_replace);

	int buildWithoutGrammarBetweenArticleAndName(	int pos_error, 
													vector<string> v_sugg, 													
													vector<string> *v_candidates, 
													string *error_replace);
	
private:
	PhraseStructure *_ora;					

	int rebuildCandidatesWithDeterminerForThePreviousTag(	int pos_error, 
															vector<string> v_sugg, 
															vector<string> v_sugg_tagged, 
															vector<string> *v_candidates,
															int type,
															int case_type = UPPER_NOTHING);
		
	int createGrammarWithContraction(	int pos_error, 
										vector<string> v_sugg, 
										vector<string> v_sugg_tagged, 
										vector<string> *v_candidates,
										int case_type = UPPER_NOTHING);

	int createGrammarWithoutContraction(int pos_error, 
										vector<string> v_sugg, 
										vector<string> v_sugg_tagged, 
										vector<string> *v_candidates,
										int type,
										int case_type = UPPER_NOTHING);

	int rebuildErrorWithDeterminerForThePreviousTag(int pos_error, int type, string *error_replace);
	int rebuildErrorWithContractionWithArticleAndName(int pos_error, string *error_replace);	

	int rebuildErrorForArticleName(int pos_error, string *error_replace);
	int rebuildErrorForPrepositionArticleName(int pos_error, string *error_replace);
	int rebuildErrorForOnlyName(int pos_error, string *error_replace);

	int getTagPosition(string tag);
	int getWordPosition(string word);
	int getPrepositionPosition(string pre);
	int getCompleteContractionWithPreposition(	string preposition, 
												string article, 
												string tag_for_name, 
												string *candidate);
	
	int getCompleteArticleWithoutPreposition(	string article, 
												string tag_for_name, 
												string *candidate);

	int getCompleteArticleWithoutPrepositionInFemale(	string article, 
														string tag_for_name, 
														string *candidate);
	
	string replaceExpression(string word, string article, string alt_article);
	
};

