/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <iostream>
#include <string>
#include <db_cxx.h>

#include "StringUtil.h"
#include "Type.h"
#include "gettext.h"

#define ENABLE_NLS 1

using namespace std;

char *msg[] = {
	"Erro o crear a base de datos",
	"Chave duplicada",
	"Erro o pechar a base de datos",
	NULL
};

int main(int argc, char *argv[])
{
  int res, nlin;
  int verbose;
  int format_error, format_lemma;
  string s, s_form, s_analysis;
  Dbt key, data;

  verbose = format_error = format_lemma = 0;
  if (argc < 3) {
	  printf("indexerror -l|-e <file> [-v]\n");
	  exit(1);
  }

  if (argc > 2) {
    if (argv[1][0] == '-' && argv[1][1] == 'e')
		format_error = 1;
    if (argv[1][0] == '-' && argv[1][1] == 'l')
		format_lemma = 1;
	if (argc > 3)
		if (argv[3][0] == '-' && argv[3][1] == 'v')
			verbose = 1;
  }

  // create database
  Db mydbase(NULL, DB_CXX_NO_EXCEPTIONS);
  if ((res = mydbase.open(NULL, argv[2], NULL,DB_HASH, DB_CREATE, 0))) {
    printf("%s: %d %s\n", msg[0], res, argv[2]);
    exit(res);
  }

  // read stdin and insert records in database
  for (nlin=0; getline(cin,s); nlin++) {

    	if (s[0] != '#' && s.size() > 1) {
			if (format_error || format_lemma) {
				// split line in key+data
				s_form = s.substr(0,s.find("="));
				s_analysis = s.substr(s.find("=") + 1);

				key.set_data((void *) s_form.c_str());
				key.set_size(s_form.length());
				data.set_data((void *) s_analysis.c_str());
				data.set_size(s_analysis.length());
			}
			else {
				key.set_data((void *) s.c_str());
				key.set_size(s.length());
				data.set_data(0);
				data.set_size(0);
			}

			res = mydbase.put(NULL, &key, &data, DB_NOOVERWRITE);
			if (res == DB_KEYEXIST && verbose) {
				printf("%s: %s %d\n", msg[0], s_form.c_str(), nlin);
			}
		}


  }

  if ((res = mydbase.close(0))) {
    printf("%s: %s\n", msg[2], res);
    exit(1);
  }
}
