/*
 *
 * Copyright (C) 2006-2007  imaxin|software
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * */

#include <string>
#include <vector>
#include <ctype.h>

#include "StringUtil.h"

using namespace std;

int StringUtil::SplitString(const string& input,
       const string& delimiter, vector<string>& results,
       bool includeEmpties)
{
    int iPos = 0;
    int newPos = -1;
    int sizeS2 = (int)delimiter.size();
    int isize = (int)input.size();

    if(
        ( isize == 0 )
        ||
        ( sizeS2 == 0 )
    )
    {
        return 0;
    }

    vector<int> positions;

    newPos = input.find (delimiter, 0);

    if( newPos < 0 )
    {
        return 0;
    }

    int numFound = 0;

    while( newPos >= iPos )
    {
        numFound++;
        positions.push_back(newPos);
        iPos = newPos;
        newPos = input.find (delimiter, iPos+sizeS2);
    }

    if( numFound == 0 )
    {
        return 0;
    }

    for( int i=0; i <= (int)positions.size(); ++i )
    {
        string s("");
        if( i == 0 )
        {
            s = input.substr( i, positions[i] );
        }
        int offset = positions[i-1] + sizeS2;
        if( offset < isize )
        {
            if( i == positions.size() )
            {
                s = input.substr(offset);
            }
            else if( i > 0 )
            {
                s = input.substr( positions[i-1] + sizeS2,
                      positions[i] - positions[i-1] - sizeS2 );
            }
        }
        if( includeEmpties || ( s.size() > 0 ) )
        {
            results.push_back(s);
        }
    }
    return numFound;
}

void StringUtil::Trim(string &input)
{
	string::size_type pos = input.find_last_not_of(' ');
	if (pos != string::npos) {
		input.erase(pos + 1);
		pos = input.find_first_not_of(' ');
		if (pos != string::npos)
			input.erase(0, pos);
	}
	else
		input.erase(input.begin(), input.end());
}

string StringUtil::ToUpper(const string input)
{
	string::iterator pos;
	string s = input;

	for (pos = s.begin(); pos != s.end(); pos++) {
		if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (isalpha(*pos)) *pos = toupper(*pos);
	}
	return(s);
}

string StringUtil::ToLower(const string input)
{
	string::iterator pos;
	string s = input;

	for (pos = s.begin(); pos != s.end(); pos++) {
		if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = '';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (*pos == '') *pos = ' ';
		else if (isalpha(*pos)) *pos = tolower(*pos);
	}
	return(s);
}

string StringUtil::ReplaceAll(string input, string search, string replace)
{
	string buffer = input;
	int pos = string::npos;

	while ( (pos = buffer.find(search, 0)) != string::npos) {
		if (replace.size() > 0)
			buffer.replace(pos, replace.size(), replace);
		else
			buffer.erase(pos, 1);
	}

	return buffer;
}

int StringUtil::isUpper(const char input)
{
	int up = 0;

	if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (input == '') up = 1;
	else if (isalpha(input)) up = isupper((int)input);

	return(up);
}

int StringUtil::isLower(const char input)
{
	int low = 0;

	if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (input == '') low = 1;
	else if (isalpha(input)) low = isupper((int)input);

	return(low);
}
